from data_func_AK_20_08_19 import *
from pylab import *
from matplotlib.colors import LogNorm

tarr = np.arange(0,78,1)
tend = tarr[-1] # last timestep you want the movie to
xmin = -1 #boundaries of movie box
xmax = 3.8
ymin = -2.5
ymax = 3
binrat = 200 # number of bins per parsec for density projection
bindist = [sqrt((xmax-xmin)**2),sqrt((ymax-ymin)**2)]
nxbins = bindist[0]*binrat
nybins = bindist[1]*binrat

def cluster(t,proj,maxden):
    # Define the x and y data
    if proj == 'XY':
        x = xg(t,0)
        y = xg(t,1)
        sx = xs(t,0)
        sy = xs(t,1)
        vxs = vs(t,0)
        vys = vs(t,1)
    elif proj=='XZ':
        x = xg(t,0)
        y = xg(t,2)
        sx = xs(t,0)
        sy = xs(t,2)
        vxs = vs(t,0)
        vys = vs(t,2)
    elif proj=='ZY':
        x = xg(t,2)
        y = xg(t,1)
        sx = xs(t,2)
        sy = xs(t,1)
        vxs = vs(t,2)
        vys = vs(t,1)
    else:
        print "Enter valid projection"
        pass

# Define the locations for the axes
    #left, width = 0.12, 0.55
    #bottom, height = 0.12, 0.55
# Set up your x and y labels
    xlabel = proj[0] + '[pc]'
    ylabel = proj[1] + '[pc]'
    #rect_temperature = [left, bottom, width, height] # dimensions of temp plot
# Set up the size of the figure
    fig = plt.figure(None,figsize=(13,13))


    axmain = plt.axes()
    axmain.set_facecolor('black') #modf 01/14/20
    xbins = linspace(start = xmin, stop = xmax, num = nxbins)
    ybins = linspace(start = ymin, stop = ymax, num = nybins)
    H, xedges,yedges = np.histogram2d(x,y,bins=(xbins,ybins))
    minden = 1
# Plot the temperature data
    cax = (axmain.imshow(H.transpose(), extent=[xmin,xmax,ymin,ymax], vmin=minden, vmax=maxden, interpolation='bicubic', origin='lower',cmap='gist_heat',norm=LogNorm()))
    cbar = plt.colorbar(cax,fraction=0.046, pad=0.04) # draw colorbar
    cbar.set_label(r'Column density (M$\odot$/pc$^{2}$)' , fontsize=30)
    cbar.ax.tick_params(labelsize=30)

#Plot the axes labels
    axmain.set_xlabel(xlabel,fontsize=30)
    axmain.set_ylabel(ylabel,fontsize=30)

#Make the tickmarks pretty
    ticklabels = axmain.get_xticklabels()
    for label in ticklabels:
        label.set_fontsize(30)


    ticklabels = axmain.get_yticklabels()
    for label in ticklabels:
        label.set_fontsize(30)


#Set up the plot limits
    axmain.plot(sx,sy,linestyle='None', marker='o',markersize=6,markerfacecolor='None', markeredgecolor='green')
    axmain.text(xmin+0.1,ymin+0.1,str(t/100.)+'Myr',color='white',fontsize=30)
    axmain.set_xlim(xmin,xmax)
    axmain.set_ylim(ymin,ymax)
    return fig

if __name__ == "__main__":
    H, xedges, yedges = np.histogram2d(xg(tend,0), xg(tend,1), bins = (nxbins, nybins))
    maxden = np.amax(H) #get the maximum density scaling from maximum velocity of the last timestep of the movie
    for j in xrange(tend+1):
        f = cluster(j,'XY',maxden)
        if j < 10:
        	n = 3
        elif j < 100:
        	n = 2
        else:
        	n = 1
        fname = '24_04_12_xy_' + '0'*n + str(j)+'.png'
        f.savefig(fname, bbox_inches= 'tight')
        print fname, 'saved'
        close(f)
